


/********************************************************************************/
/*																				*/
/********************************************************************************/
#define	uchar	unsigned char
#define	byte	unsigned char
#define	uint	unsigned int
#define	word	unsigned int
#define	ulong	unsigned long
#define	dword	unsigned long
#define	FALSE	0
#define	TRUE	1
#define	false	FALSE
#define	true	TRUE
#define	False	FALSE
#define	True	TRUE


#define	NONE		-1
#define	PARITYERR	-2
#define	FRAMEERR	-3
#define	OVERRUNERR	-4

#define	CRLF	"\r\n"
#define	CR		'\r'
#define	LF		'\n'
#define	ESC		0x2B
#define	EXIT	ESC


#include <avr/io.h>									// IO
#include <stdio.h>									//
#include <stdlib.h>									//
#include <avr/sfr_defs.h>							// SFR, _BV(bit)
#include <avr/pgmspace.h>							// Flash
#define  CODE PROGMEM
#include <avr/interrupt.h>							// wektory IRQ
#include <avr/wdt.h> 								// WDG
#include <avr/eeprom.h>								// Eeprom
#include <string.h>									// Stringi
#include <compat/deprecated.h>						// sbi, cbi, inb, outb, outp
#define  ebi(port,bit) ( port ^= (1 << (bit)))		// Negowanie bitu na porcie
#define	BAUD	250000
#include <util/setbaud.h>							// Uart 0
//#define	BAUD1	9600
//#include "include/setbaud1.h"						// Uart 1
#include <util/delay.h>
#include <util/crc16.h>								// Crc16, Xmodem, Dallas
#include <avr/fuse.h>
#define NOINIT __attribute__ ((section(".noinit")))
#define nop()	__asm__ __volatile__( "nop" )		// Wstawia rozkaz NOP do kodu
#include <avr/sleep.h>								// Tryby upienia
#include <avr/power.h>								// Wyaczanie peryferii



//---------------------------------------------------------------------------------------
/*
// Interrupt Vectors
// Interrupt Vector 0 is the reset vector.
#define INT0_vect         _VECTOR(1)   // External Interrupt Request 0
#define INT1_vect         _VECTOR(2)   // External Interrupt Request 1
#define PCINT0_vect       _VECTOR(3)   // Pin Change Interrupt Request 0
#define PCINT1_vect       _VECTOR(4)   // Pin Change Interrupt Request 0
#define PCINT2_vect       _VECTOR(5)   // Pin Change Interrupt Request 1
#define WDT_vect          _VECTOR(6)   // Watchdog Time-out Interrupt
#define TIMER2_COMPA_vect _VECTOR(7)   // Timer/Counter2 Compare Match A
#define TIMER2_COMPB_vect _VECTOR(8)   // Timer/Counter2 Compare Match A
#define TIMER2_OVF_vect   _VECTOR(9)   // Timer/Counter2 Overflow
#define TIMER1_CAPT_vect  _VECTOR(10)  // Timer/Counter1 Capture Event
#define TIMER1_COMPA_vect _VECTOR(11)  // Timer/Counter1 Compare Match A
#define TIMER1_COMPB_vect _VECTOR(12)  // Timer/Counter1 Compare Match B
#define TIMER1_OVF_vect   _VECTOR(13)  // Timer/Counter1 Overflow
#define TIMER0_COMPA_vect _VECTOR(14)  // TimerCounter0 Compare Match A
#define TIMER0_COMPB_vect _VECTOR(15)  // TimerCounter0 Compare Match B
#define TIMER0_OVF_vect   _VECTOR(16)  // Timer/Couner0 Overflow
#define SPI_STC_vect      _VECTOR(17)  // SPI Serial Transfer Complete
#define USART_RX_vect     _VECTOR(18)  // USART Rx Complete
#define USART_UDRE_vect   _VECTOR(19)  // USART, Data Register Empty
#define USART_TX_vect     _VECTOR(20)  // USART Tx Complete
#define ADC_vect          _VECTOR(21)  // ADC Conversion Complete
#define EE_READY_vect     _VECTOR(22)  // EEPROM Ready
#define ANALOG_COMP_vect  _VECTOR(23)  // Analog Comparator
#define TWI_vect          _VECTOR(24)  // Two-wire Serial Interface
#define SPM_READY_vect    _VECTOR(25)  // Store Program Memory Read

void* tim_handler;
ISR(TIMER2_COMP_vect,ISR_NAKED)
{
asm("ijmp"::"z"(tim_handler));
}

Skoro "program gwny" nic nie robi to przerwanie nigdy nie moe zepsu jego stanu, a wic nie ma powodu eby obsuga przerwan zapisywaa rejestry czy cokolwiek - dlatego ISR_NAKED.


*/



//---------------------------------------------------------------------------------------
#define	OVERTIME_DMX	1 * 100		// Liczba sekund do trybu ofline w 10ms
word volatile TimerDmx0, TimerDmx1, TimerRefresh;
void InitTimer0();
void InitTimer2();
void InitTimer1();


#define	ddrLedRun()	DDRA  |=  (1<<PA5)
#define	SetLedRun()	PORTA &= ~(1<<PA5)
#define	ClrLedRun()	PORTA |=  (1<<PA5)
#define	EorLedRun()	PORTA ^=  (1<<PA5)

#define	ddrLedCh1()	DDRA  |=  (1<<PA6)
#define	SetLedCh1()	PORTA &= ~(1<<PA6)
#define	ClrLedCh1()	PORTA |=  (1<<PA6)
#define	EorLedCh1()	PORTA ^=  (1<<PA6)

#define	ddrLedCh2()	DDRA  |=  (1<<PA7)
#define	SetLedCh2()	PORTA &= ~(1<<PA7)
#define	ClrLedCh2()	PORTA |=  (1<<PA7)
#define	EorLedCh2()	PORTA ^=  (1<<PA7)



#define	MIN_DMX_OFLINE	1			// Czas braku transmisji w sekundach, uznany jako brak sygnalu DMX
enum{DMX_OFFLINE, DMX_BREAK};


#define	LENBUFDMX	256+1
void InitUart0();
byte RxBuf0[ LENBUFDMX ];
byte TxBuf0[ LENBUFDMX ];
byte DmxStatus0 = DMX_OFFLINE;
word volatile LenDmx0, PtrTxRs;
byte volatile TxEmpty = TRUE;

#define	DdrTx()			DDRD  |=  (1<<PD1);			// Port wyjsciem
#define	ClrTx()			PORTD &= ~(1<<PD1);			// wygeneruj BREAK
#define	SetTx()			PORTD |=  (1<<PD1);			// wygeneruj MAB
void SendDmx( word len );
word LenTxRs;

void InitUart1();
byte RxBuf1[ LENBUFDMX ];
byte DmxStatus1 = DMX_OFFLINE;
word volatile LenDmx1;


//**********************************************************************//
//						Bity konfiguracyjne		 						//
//**********************************************************************//
__fuse_t __fuse __attribute__((section (".fuse"))) =
#if defined(__AVR_ATmega162__)
{
	.extended	= 0xF9,
	.high		= 0x99,
	.low		= 0xDF,
};
#else
	#error "NIEZNANY TYP PROCESORA w ustawieniu bitow konfiguracyjnych"
#endif


/*
__attribute__((section (".lock"))) const unsigned char __lock =
0xFC;
*/


//**********************************************************************//
//						Program glowny			 						//
//**********************************************************************//
int main()
{
word cnt;
byte dzielLedRun=2;


	InitTimer0();

	InitUart0();
	InitUart1();

	//--- init WDG ---
	//WDTO_15MS
	//WDTO_30MS
	//WDTO_60MS
	//WDTO_120MS
	//WDTO_250MS
	//WDTO_500MS
	//WDTO_1S
	//WDTO_2S
	wdt_enable( WDTO_500MS );									// Blokuje IRQ !!!

	ddrLedRun();
	ddrLedCh1();
	ddrLedCh2();


	SetLedRun();
	ClrLedCh1();
	ClrLedCh2();

	sei();


	SendDmx( 24 );		// Init nadawania
	InitUart0();
	InitUart1();



	//-----------------------------------------------------------------------------------
	//								Petla glowna
	//-----------------------------------------------------------------------------------
	while( 1 )
	{
		wdt_reset();

		if ( !TimerRefresh )
			{
			TimerRefresh = 25;		// Co 250ms odswierzamy


			if ( (--dzielLedRun)==0 )
				{
				dzielLedRun = 2;
				EorLedRun();
				}


			if ( DmxStatus0 != DMX_OFFLINE ) { SetLedCh1(); } else { ClrLedCh1(); }
			if ( DmxStatus1 != DMX_OFFLINE ) { SetLedCh2(); } else { ClrLedCh2(); }


			if ( DmxStatus0 == DMX_OFFLINE )
				{
				for( cnt=0; cnt<LENBUFDMX; cnt++)
					{
					RxBuf0[ cnt ] = 0;
					}
				}
/*
DmxStatus1=DMX_BREAK; LenDmx1=24; //TEST
//TEST
RxBuf1[1] = 0x10;
RxBuf1[2] = 0x7f;
*/
			if ( DmxStatus1 == DMX_OFFLINE )
				{
				for( cnt=0; cnt<LENBUFDMX; cnt++)
					{
					RxBuf1[ cnt ] = 0;
					}
				}
			}


		//--- Wysanie ramki DMX ---//
		if ( TxEmpty )		// Jeli poprzednia ramka wyslana
			{
			for( cnt=0; cnt<LENBUFDMX; cnt++)
				{
				TxBuf0[ cnt ] = RxBuf0[ cnt ];
				if ( RxBuf1[ cnt] > RxBuf0[ cnt] ){ TxBuf0[ cnt ] = RxBuf1[ cnt ]; }
				}

			cnt = LenDmx0; if ( LenDmx1 > LenDmx0 ) { cnt = LenDmx1; }
			if ( (DmxStatus0 != DMX_OFFLINE) || (DmxStatus1 != DMX_OFFLINE))
				{
				SendDmx( cnt+1 );				// Nadajemy tylko gdy jest transmisja na ktrym porcie
				}
			else
				{
				cnt = 0;
				}
			}
	}
}



//**********************************************************************//



//-------------------------------------------------------------------------
//					Init timer 0
//-------------------------------------------------------------------------
void InitTimer0()
{
	TCCR0 = 5;							// podzielnik 1024
	TIMSK |= (1<<TOIE0);				// Zezwolenie na IRQ od przepelnienia timera
}


//----------------------------------------------------------------------//
//					Obsuga IRQ od timera 0 - czasy MAB
//----------------------------------------------------------------------//
INTERRUPT( TIMER0_OVF_vect )			// Mozliwe przerwanie wielopoziomowe (pierwsza instrukcja SEI)
{
	TCNT0 = 256 - 157;					// Przerwania co okoo 10ms


	if ( TimerDmx0 ) TimerDmx0--;
	if ( TimerDmx1 ) TimerDmx1--;
	if ( TimerRefresh )  TimerRefresh--;

	if ( TimerDmx0 == 1) { DmxStatus0 = DMX_OFFLINE; LenDmx0 = 0; }
	if ( TimerDmx1 == 1) { DmxStatus1 = DMX_OFFLINE; LenDmx1 = 0; }
}


//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart0()
{
	nop();
#if F_CPU == 16000000
	UBRR0H = 0;
	UBRR0L = 3;			// Dla 16MHz
//	UCSR0A = (1<<U2X0);
#elif F_CPU == 8000000
	UBRR0H = 0;			// Dla 8MHz
	UBRR0L = 1;			// Tablica 19-11 str 196
	UCSR0A = 0;
#else
 #error "Nieznane FCLK"
#endif
	UCSR0B = (1<<RXEN0) | (1<<TXEN0) | (1<<RXCIE0) | (1<<TXCIE0);
	UCSR0C = (1<<USBS0) | (3<<UCSZ00);								// Set frame format: 8data, 2stop bit
}


//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
//INTERRUPT( USART_RX_vect )		// Mozliwe przerwanie wielopoziomowe
SIGNAL( USART0_RXC_vect )			// Nie mozliwe przerwanie wielopoziomowe
{
byte UsartStatus, UsartDana;
word static CntDanych, curLenDmx, prevLenDmx;


	UsartStatus = UCSR0A;
	UsartDana = UDR0;


	if ( (UsartStatus & (1<<FE0)) )			// Jesli wykryto blad ramki to skonczyl sie sygnal BREAK
		{
		TimerDmx0 = OVERTIME_DMX;
		DmxStatus0 = DMX_BREAK;				// Ustaw status
		prevLenDmx = curLenDmx;				// Zapamietaj poprzedni dugo
		curLenDmx = CntDanych;  			// Zapamitaj aktualn
		CntDanych = 0;						// Zeruj licznik danych
		if ( prevLenDmx==curLenDmx ) LenDmx0 = curLenDmx-1;	// Zapamitaj dugo danych gdy dwa wyniki takie same
		}
	else if(DmxStatus0 == DMX_BREAK)		// Jesli byl BREAK a pojawila sie nowa dana:
		{
		if ( CntDanych < LENBUFDMX ) RxBuf0[ CntDanych++ ] = UsartDana;	// nastepny kanal
		}

}


//----------------------------------------------------------------------//
void SendDmx( word len )
{
	if (!TxEmpty){ return; }

	LenTxRs = len;
	if ( LenTxRs > LENBUFDMX ) LenTxRs = LENBUFDMX;
	TxEmpty = FALSE;

//EorLedCh2();	// TEST

	//--- jakas babula w procku i "rozstraja" sie  rejestr UBRR ---//
	UBRR0H = 0;
	UBRR0L = 3;			// Dla 16MHz

	// Program gwny generuje BREAK i MAB po czym wyle dane (wpis do UDR0)
	UCSR0B &= ~(1<<TXEN0);				// wycz TX UARTA
	DdrTx();							// Port wyjsciem
	ClrTx(); _delay_us(200);			// wygeneruj BREAK
	SetTx(); _delay_us(100);			// wygeneruj MAB
	UCSR0B |= (1<<TXEN0);				// wcz TX UARTA
	UDR0 = TxBuf0[ PtrTxRs=0 ];			// Wpisz do nadajnika pierwszy znak (start transmisji)
}


//----------------------------------------------------------------------//
//				Przerwanie nadawcze od uarta
//----------------------------------------------------------------------//
#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
#define USART_TX_vect     _VECTOR(20)  /* USART Tx Complete */
//----------------------------------------------------------------------//
SIGNAL(USART0_TXC_vect)		// Musi byc ISR lub SIGNAL a nie INTERUPT
{
	PtrTxRs++;							// Wskanik na nastpny znak
	if ( PtrTxRs < LenTxRs )			// Jeli s jeszcze znaki do wysania
		{
		UDR0 = TxBuf0[ PtrTxRs ];		// Wpisz do nadajnika
		}
	else
		{
		TxEmpty = TRUE;					// Wszystkie znaki wysane (ostatnie IRQ)
		}
}


//------------------------------------------------------------------------------
//					Inicjalizacja USART-a
//------------------------------------------------------------------------------
void InitUart1()
{
	nop();
#if F_CPU == 16000000
	UBRR1H = 0;
	UBRR1L = 3;			// Dla 16MHz
//	UCSR1A = (1<<U2X0);
#elif F_CPU == 8000000
	UBRR1H = 0;			// Dla 8MHz
	UBRR1L = 1;			// Tablica 19-11 str 196
	UCSR1A = 0;
#else
 #error "Nieznane FCLK"
#endif
	UCSR1B = (1<<RXEN1) | (1<<RXCIE1);
	UCSR1C = (1<<USBS1) | (3<<UCSZ10);								// Set frame format: 8data, 2stop bit
}


//----------------------------------------------------------------------//
//					Obsluga IRQ od odbiornika USART-a
//------------------------------------------------------------------------------
//#define USART_RX_vect     _VECTOR(18)  /* USART Rx Complete */
//#define USART_UDRE_vect   _VECTOR(19)  /* USART, Data Register Empty */
//
//INTERRUPT( USART_RX_vect )		// Mozliwe przerwanie wielopoziomowe
SIGNAL( USART1_RXC_vect )			// Nie mozliwe przerwanie wielopoziomowe
{
byte UsartStatus, UsartDana;
word static CntDanych, curLenDmx, prevLenDmx;


	UsartStatus = UCSR1A;
	UsartDana = UDR1;


	if ( (UsartStatus & (1<<FE1)) )			// Jesli wykryto blad ramki to skonczyl sie sygnal BREAK
		{
		TimerDmx1 = OVERTIME_DMX;
		DmxStatus1 = DMX_BREAK;				// Ustaw status
		prevLenDmx = curLenDmx;				// Zapamietaj poprzedni dugo
		curLenDmx = CntDanych;  			// Zapamitaj aktualn
		CntDanych = 0;						// Zeruj licznik danych
		if ( prevLenDmx==curLenDmx ) LenDmx1 = curLenDmx-1;	// Zapamitaj dugo danych gdy dwa wyniki takie same
	//--- jakas babula w procku i "rozstraja" sie  rejestr UBRR ---//
	UBRR1H = 0;
	UBRR1L = 3;			// Dla 16MHz
		}
	else if(DmxStatus1 == DMX_BREAK)		// Jesli byl BREAK a pojawila sie nowa dana:
		{
		if ( CntDanych < LENBUFDMX ) RxBuf1[ CntDanych++ ] = UsartDana;	// nastepny kanal
		}

}



